// HummingBirdNTSet.cpp : implementation of the CHummingBirdNTSet class
//
//The Set class is the main Database engine.  At this time I think that
// any class that needs to perform any Database related work must work 
// through the Document class, which calls functions in this class.
// (Chad Thompson 1 January 1998)
//Todo: Add in SQL functions into this class. (CT 1jan98)
//Todo: Add in Record traversing functions into this class (CT 2jan98)
//Todo: Check to see if the DB variables can be changed from m_<name> to
// db_<name> and implement.

#include "stdafx.h"
#include "HummingBirdNT.h"
#include "HummingBirdNTSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHummingBirdNTSet implementation

IMPLEMENT_DYNAMIC(CHummingBirdNTSet, CDaoRecordset)

CHummingBirdNTSet::CHummingBirdNTSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//Module Description:
	//This function initializes the variables used in the class.
	//
	//Module Specification:
	//As the constructor, this runs when the class is instanciated.
	//
	//Unit Test Details:
	//If the class loads correctly this runs correctly.
	//
	//Internal Data Description:
	//All class variable initial settings are made here.

	//{{AFX_FIELD_INIT(CHummingBirdNTSet)
	m_accept_list_filter = _T("");
	m_accept_list_host = _T("");
	m_config_time_time = 0;
	m_filter_expression = _T("");
	m_filter_trust = 0;
	m_filter_log = 0;
	m_filter_alert = 0;
	m_filter_inh = 0;
	m_forward_list_filter = _T("");
	m_forward_list_host = _T("");
	m_log_trust = 0;
	m_log_description = _T("");
	m_log_hostip = _T("");
	m_log_file = _T("");
	m_log_tool = _T("");
	m_manager_manager = _T("");
	m_subordinates_hum_name = _T("");
	m_subordinates_subord = _T("");
	m_trust_start_addr = _T("");
	m_trust_end_addr = _T("");
	m_trust_level = 0;
	m_trust_inh = 0;
	m_nFields = 27;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CHummingBirdNTSet::GetDefaultDBName()
{
	//Module Description:
	//Get's the defailt database name.
	//Note: This must be changed eventually into a dynamic way to find
	// the database file.
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:
	//Database file and it's path.
	//Note: Must have a double front slash "\\" instead of a single one.

	return _T("C:\\backup\\DevStudio\\HummingBirdNT\\HummerNT.mdb");
}


CString CHummingBirdNTSet::GetDefaultSQL()
{
	//Module Description:
	//This shows the default table names used in the DAO.
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:
	//Text table names used by the program that are in the database file.

	return _T("[accept_list],[config_time],[filter],[forward_list],[log],[manager],[subordinates],[trust]");
}

void CHummingBirdNTSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//Module Description:
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

	//{{AFX_FIELD_MAP(CHummingBirdNTSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[accept_list_filter]"), m_accept_list_filter);
	DFX_Text(pFX, _T("[accept_list_host]"), m_accept_list_host);
	DFX_Long(pFX, _T("[config_time_time]"), m_config_time_time);
	DFX_Text(pFX, _T("[filter_expression]"), m_filter_expression);
AfxMessageBox(m_filter_expression);	//testing
	DFX_DateTime(pFX, _T("[filter_date_start]"), m_filter_date_start);
	DFX_DateTime(pFX, _T("[filter_date_end]"), m_filter_date_end);
	DFX_DateTime(pFX, _T("[filter_time_start]"), m_filter_time_start);
	DFX_DateTime(pFX, _T("[filter_time_end]"), m_filter_time_end);
	DFX_Long(pFX, _T("[filter_trust]"), m_filter_trust);
	DFX_Long(pFX, _T("[filter_log]"), m_filter_log);
	DFX_Long(pFX, _T("[filter_alert]"), m_filter_alert);
	DFX_Long(pFX, _T("[filter_inh]"), m_filter_inh);
	DFX_Text(pFX, _T("[forward_list_filter]"), m_forward_list_filter);
	DFX_Text(pFX, _T("[forward_list_host]"), m_forward_list_host);
	DFX_Long(pFX, _T("[log_trust]"), m_log_trust);
	DFX_DateTime(pFX, _T("[log_date]"), m_log_date);
	DFX_Text(pFX, _T("[log_description]"), m_log_description);
	DFX_Text(pFX, _T("[log_hostip]"), m_log_hostip);
	DFX_Text(pFX, _T("[log_file]"), m_log_file);
	DFX_Text(pFX, _T("[log_tool]"), m_log_tool);
	DFX_Text(pFX, _T("[manager_manager]"), m_manager_manager);
	DFX_Text(pFX, _T("[subordinates_hum_name]"), m_subordinates_hum_name);
	DFX_Text(pFX, _T("[subordinates_subord]"), m_subordinates_subord);
	DFX_Text(pFX, _T("[trust_start_addr]"), m_trust_start_addr);
	DFX_Text(pFX, _T("[trust_end_addr]"), m_trust_end_addr);
	DFX_Long(pFX, _T("[trust_level]"), m_trust_level);
	DFX_Long(pFX, _T("[trust_inh]"), m_trust_inh);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CHummingBirdNTSet diagnostics

#ifdef _DEBUG
void CHummingBirdNTSet::AssertValid() const
{
	//Module Description:
	//Asserts itself as valid (I believe when the class is created, as a
	// diagnostic tool).
	//
	//Module Specification:
	//Created by VC++
	//
	//Unit Test Details:
	//If the Form loads this function works.
	//
	//Internal Data Description:
	//None

	CDaoRecordset::AssertValid();
}

void CHummingBirdNTSet::Dump(CDumpContext& dc) const
{
	//Module Description:
	//Dumps the dc (I think it destroys the GUI)
	//
	//Module Specification:
	//Called when the object is destroyed.
	//
	//Unit Test Details:
	//None, created and used by code created by the VC++ Wizards.
	//
	//Internal Data Description:
	//

	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
